package com.ruoyi.wx.web.service.impl;

import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.framework.recovery.domain.WxUserLottery;
import com.ruoyi.framework.recovery.mapper.WxUserLotteryMapper;
import com.ruoyi.wx.web.domain.dto.LotteryDto;
import com.ruoyi.wx.web.domain.vo.LotteryVo;
import com.ruoyi.wx.web.service.IWxLotteryUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class WxLotteryUserServiceImpl implements IWxLotteryUserService {
    @Autowired
    private WxUserLotteryMapper wxUserLotteryMapper;

    @Override
    public LotteryVo getList() {
        WxUserLottery lottery = new WxUserLottery();
        String wxOpenid = SecurityUtils.getLoginWxUser().getWxUser().getWxOpenid();
        lottery.setOpenId(wxOpenid);
        List<WxUserLottery> userLotteries = wxUserLotteryMapper.selectWxUserLotteryList(lottery);
        List<String> lotteryIds = new ArrayList<>();
        for (WxUserLottery userLottery : userLotteries) {
            lotteryIds.add(userLottery.getLotteryNum());
        }
        LotteryVo result = new LotteryVo();
        result.setLotteryCodes(lotteryIds);
        result.setLotteryNum(lotteryIds.size());
        return result;
    }

    @Override
    public LotteryVo addLottery(LotteryDto lotteryDto) {
        String wxOpenid = SecurityUtils.getLoginWxUser().getWxUser().getWxOpenid();
        WxUserLottery lottery = new WxUserLottery();
        lottery.setOpenId(wxOpenid);
        List<WxUserLottery> userLotteries = wxUserLotteryMapper.selectWxUserLotteryList(lottery);
        int total = lotteryDto.getNum() + userLotteries.size();
        if (total > 10) {
            throw new ServiceException("超出抽奖数量阈值");
        }
        List<WxUserLottery> dto = new ArrayList<>();
        for (int i = 0 ; i < lotteryDto.getNum() ; i++) {
            WxUserLottery info = new WxUserLottery();
            info.setOpenId(wxOpenid);
            String lotteryCode = String.valueOf(System.currentTimeMillis()).substring(7);
            lotteryCode = lotteryCode + i;
            info.setLotteryNum(lotteryCode);
            info.setLotteryType(lotteryDto.getType());
        }
        return null;
    }
}
